<?php

/*//. KatePKG - A GUI (GTK2) Package Manger for KateOS.
Written by Bob Majdak Jr <bob@kateos.org>.

This program is released under the GNU GPL.

See $PREFIX/bin/katepkg for details .//*/

// ///////////////////////////////////////////////////
// local file operations                                                     //
                                         /////////////////////////////////// //

function katepkg_filesize($size) {

	//. not  using exact values for compare, so we can have returned values
	//. like 0.9 etc... purely for sex appeal.

	if($size >= 1000000) {
		return sprintf("%.1f MB",(($size / 1024) / 1024));
	} else if($size >= 1000) {
		return sprintf("%.1f KB",($size / 1024));
	} else {
		return sprintf("%.1f B",($size));
	}

}

function katepkg_check_md5($file) {

	if(!file_exists($file) || !file_exists($file.".md5")) {
		return FALSE;
	}

	if(str_replace("\n","",file_get_contents($file.".md5")) == md5_file($file)) {
		return TRUE;
	} else {
		return FALSE;
	}	
	
}

function katepkg_is_installed($package) {

	global $pkglist;

	if($pkglist[$package][0]) {
		return TRUE;
	} else {
		return FALSE;
	}

}

function katepkg_get_deps($file) {

	//. nothing i would write in php could be faster than the real tar application,
	//. so we'll just use that.
	$depout = explode("\n",preg_replace("/[\s\n]+$/","",`tar -xzOf $file install/deps`));
	
	//. removing blank lines (for the end of the file more than anything).
	for($a = 0; $a < count($depout); $a++) {
//		printf("%d: \"%s\"\n",$a,$depout[$a]);
		if(preg_match("/^\s*$/",$depout[$a])) {
			unset($depout[$a]);
		}
	}
	
	return $depout;
}

function katepkg_find_packages($dir) {
	
	$dp = opendir($dir);
	while($file = readdir($dp)) {
		if(preg_match("/tgz$/",$file)) {
			$list[] = $dir."/".$file;
		}
	}
	closedir($dp);
	
	return $list;	
	
}

// ///////////////////////////////////////////////////
// remote file operations                                                    //
                                         /////////////////////////////////// //
                                         
function katepkg_download_break() {
	global $download,$dlpp;
	if($dlpp) {
		pclose($dlpp);
	}
	$download = $dlpp = FALSE;
}

function katepkg_filesize_remote($url) {

		preg_match("/((?:https?:|ftp:|file:\/)\/\/)([^\/]+)(\/.+)/",$url,$urlmatch);
		
		if(preg_match("/^file:\/\//",$urlmatch[0])) {
			return filesize($urlmatch[0]);
			//return filesize(preg_replace("/^file:\/\//","",$urlmatch[0]));
		} else {
			$sp = fsockopen($urlmatch[2],80);
		}
		if(!$sp) {
			return FALSE;
		}

		fwrite($sp,"HEAD " . $urlmatch[3] . " HTTP/1.1\r\n");
		fwrite($sp,"Host: " . $urlmatch[2] . "\r\n");
		fwrite($sp,"User-agent: KatePKG v".VERSION." ".NAME."\r\n");
		fwrite($sp,"Connection: close\r\n\r\n");
		while($recv = fgets($sp)) {
			if(preg_match("/Content\-Length: ([0-9]+)/i",$recv,$recvmatch)) {
				$size = (int)$recvmatch[1];
				fclose($sp);
				break;
			}
		}
		
		return $size;
}


?>